<?php

	$starttime = time();
	$delay = gpc("delay");
	
	if ($delay != "")
		sleep($delay);
		
    header("Cache-Control: no-cache");
    header("Pragma: no-cache");
	
	
	$clientTime = gpc("clienttime");
	$requestID = gpc("id");
	$requestIP = $_SERVER['REMOTE_ADDR'];
	$responseStatus = gpc("responsestatus");
	$xmlError = gpc("xmlerror");
	
	
	if ($responseStatus == "200")
		header("HTTP/1.1 200 OK\n\n");
    else if ($responseStatus == "204")
		header("HTTP/1.1 204 No Content\n\n");
	else if ($responseStatus == "403")
		header("HTTP/1.1 403 Forbidden\n\n");
    else if ($responseStatus == "404")
	    header("HTTP/1.1 404 Not Found\n\n");
    else if ($responseStatus == "500")
	    header("HTTP/1.1 500 Internal Server Error\n\n");
    else if ($responseStatus == "501")
	    header("HTTP/1.1 501 Not Implemented\n\n");
    else if ($responseStatus == "502")
	    header("HTTP/1.1 502 Bad Gateway\n\n");
    else if ($responseStatus == "503")
	    header("HTTP/1.1 503 Service Unavailable\n\n");
    else if ($responseStatus == "504")
	    header("HTTP/1.1 504 Gateway Timeout\n\n");
    else if ($responseStatus == "505")
	    header("HTTP/1.1 505 HTTP Version Not Supported\n\n");

	if ($responseStatus && $responseStatus != "200")exit;	

    if ($xmlError != "Wrong Content Type")
		header("Content-Type: text/xml");
	else
		header("Content-Type: text/html");
		
	$xml = new DOMDocument('1.0', 'UTF-8');
	$root = $xml->createElement("network");
	
	if ($xmlError == "Wrong Content")
	{
		$wrongData = $xml->createElement("wrongData");
		$wrongData->appendChild($xml->createTextNode("This is not the right XML Packet."));
		$root->appendChild($wrongData);
	
	}
	else
	{
		$requestIDNode = $xml->createElement("requestid");
		$requestIDNode->appendChild($xml->createTextNode($requestID));
		$root->appendChild($requestIDNode);
		
		$requestIPNode = $xml->createElement("requestip");
		$requestIPNode->appendChild($xml->createTextNode($requestIP));
		$root->appendChild($requestIPNode);
		
		$requestDateNode = $xml->createElement("serverdate");
		$requestDateNode->appendChild($xml->createTextNode(date("h:i:s A")));
		$root->appendChild($requestDateNode);
		
		$totalTime = time() - $starttime;
		
		$totalTimeNode = $xml->createElement("timeserver");
		$totalTimeNode->appendChild($xml->createTextNode(date("i:s", $totalTime)));
		$root->appendChild($totalTimeNode);
	}
	
	$xml->appendChild($root);

	$xmlString =  $xml->saveXML();
	
	if ($xmlError == "Malformed XML")
		$xmlString .= "<badstring>baddata";
	
	print $xmlString;
	
	
	
/* Helper functions */
function gpc($name)
{
    if (isset($_GET[$name]))
	return $_GET[$name];
    else if (isset($_POST[$name]))
	return $_POST[$name];
    else if (isset($_COOKIE[$name]))
	return $_COOKIE[$name];
    else
	return "";
}
?>
